%%
load('data_Reforming_Resistance_Simulation.mat');
figure(1);
%% r
plot(rm,'k-','linewidth',0.8);
axis([8000 32000 3.36 4.15]);
xlabel('Time(s)','FontSize',9);
ylabel('Resistance Load()','FontSize',9);
title('','FontSize',9);
%%
figure(2);
%% h
subplot(2,1,1);
plot(hm,'b-','linewidth',0.8);
hold on;
plot(hs,'r--','linewidth',0.8);
axis([8000 32000 1.8 3.6]);
legend('MFPC','SFPC');
ylabel('Hydrogen Flow Rate(10^-4mol/s)','FontSize',9);
title('','FontSize',9);
set(gca,'xtick',[],'xticklabel',[])
%% a
subplot(2,1,2);
plot(am,'b-','linewidth',0.8);
hold on;
plot(as,'r--','linewidth',0.8);
axis([8000 32000 -10 230]);
legend('MFPC','SFPC');
xlabel('Time(s)','FontSize',9);
ylabel('Air Flow Rate(10^-3mol/s)','FontSize',9);
title('','FontSize',9);
%%
figure(3);
%% v
subplot(2,1,1);
plot(vm,'color',[1,0.5,0],'Linestyle','-','linewidth',0.8);
hold on;
plot(vs,'color',[0,0.75,0.75],'Linestyle','-.','linewidth',0.8);
hold on;
plot(vsetm,'color',[0.75,0,0.75],'Linestyle',':','linewidth',0.8);
hold on;
axis([8000 32000 135.5 144.3]);
legend('MFPC','SFPC','Voltage Reference');
ylabel('Output Voltage(V)','FontSize',9);
title('','FontSize',9);
set(gca,'xtick',[],'xticklabel',[])
%% fu
subplot(2,1,2);
plot(fum,'color',[1,0.5,0],'Linestyle','-','linewidth',0.8);
hold on;
plot(fus,'color',[0,0.75,0.75],'Linestyle','-.','linewidth',0.8);
hold on;
axis([8000 32000 0.52 0.97]);
legend('MFPC','SFPC');
xlabel('Time(s)','FontSize',9);
ylabel('Fuel Utilization Rate','FontSize',9);
title('','FontSize',9);