function ud=SOFC_MFPC(u)
global P M Ts nu ny nd z1 z2 w1 w2;
global uu du x_k Q R P_k QP dk A Bu Bd C F W Z S e1 e2;
global umin1 umin2  umax1 umax2 delt_umin1 delt_umin2 delt_umax1 delt_umax2;
%% MPC Parameters
Ts=20;  P=30; M=20;
ny=2;nu=2;nd=1;
z1=40; z2=550;
w1=10; w2=1;
umax1=25;  umax2=200;
umin1=1; umin2=3;
delt_umax1=0.03;  delt_umax2=50;
delt_umin1=-0.03; delt_umin2=-50;
%% Get the global model
load('Identification.mat');
sys_discrete_a=c2d(sys_ss_a,Ts);
A1_a=sys_discrete_a.a; B1_a=sys_discrete_a.b; C1_a=sys_discrete_a.c;
sys_discrete_b=c2d(sys_ss_b,Ts);
A1_b=sys_discrete_b.a; B1_b=sys_discrete_b.b; C1_b=sys_discrete_b.c;
sys_discrete_c=c2d(sys_ss_c,Ts);
A1_c=sys_discrete_c.a; B1_c=sys_discrete_c.b; C1_c=sys_discrete_c.c;
sys_discrete_d=c2d(sys_ss_d,Ts);
A1_d=sys_discrete_d.a; B1_d=sys_discrete_d.b; C1_d=sys_discrete_d.c;
if u(5)<3.8
    if u(5)<3.6
        a=(3.6-u(5))/0.2;
        b=(u(5)-3.4)/0.2;
        c=0;
        d=0;
    else
        a=0;
        b=(3.8-u(5))/0.2;
        c=(u(5)-3.6)/0.2;
        d=0;
    end
else
        a=0;
        b=0;
        c=(4.1-u(5))/0.3;
        d=(u(5)-3.8)/0.3;
end
A1=a*A1_a+b*A1_b+c*A1_c+d*A1_d;
B1=a*B1_a+b*B1_b+c*B1_c+d*B1_d;
C1=a*C1_a+b*C1_b+c*C1_c+d*C1_d;
Bu1=B1(:,1:nu);Bd1=B1(:,nu+1:nu+nd);
%% The prediction model
n1=size(A1,1);
A=[A1,zeros(n1,ny);C1*A1,eye(ny,ny)];
Bu=[Bu1;C1*Bu1];
Bd=[Bd1;C1*Bd1];
C=[zeros(ny,n1),eye(ny,ny)];
n2=size(A,1);
F=cell(P,1);
for i=1:P
    F{i}=C*A^i;
end
F=cell2mat(F);
e1=cell(P,M);
for i=1:P
    for j=1:M
        if i<j
            e1{i,j}=zeros(ny,nu);
        else
            e1{i,j}=C*A^(i-j)*Bu;
        end
    end
end
e1=cell2mat(e1);
e2=cell(P,1);
for i=1:P
    e2{i}=C*A^(i-1)*Bd;
end
e2=cell2mat(e2);
Z0=[z1,z2];
for i=1:P-1
    Z0=[Z0,z1,z2];
end
Z=diag(Z0);
W0=[w1,w2];
for i=1:M-1
    W0=[W0,w1,w2];
end
W=diag(W0);
S=cell(P,M);
for i=1:M
    for j=1:M
        if i>=j
            S{i,j}=eye(nu);
        else
            S{i,j}=zeros(nu);
        end
    end
end
S=cell2mat(S); 
%% Kalman filter Parameters
Q=eye(n2);R=eye(ny); P_k=eye(n2);
%% Initialization
if u(6)<20
    y1=140;y2=0.8;
    uu=[2.667;9.5];
    du=zeros(nu,1);
    x_k=[zeros(n2-ny,1);y1;y2];
    dk=3.4*ones(nd,1);
end
%% MPC Main Program
if u(6)<10000
    ud=uu;
else
yr_1=u(1);
yr_2=u(2);
yr=[yr_1;yr_2];
y1_measure=u(3);
y2_measure=u(4);
dk_1=u(5);
y_measure=[y1_measure;y2_measure];
for i=1:P
    yr1{i}=blkdiag(1,1)*yr;
end
Yr=cat(1,yr1{1:P});
delt_dk=dk_1-dk;
dk=dk_1;
x_k_1=A*x_k+Bu*du+Bd*delt_dk;
P_k_1=1.2*A*P_k*A'+Q;
ek=y_measure-C*x_k_1;
Sk=C*P_k_1*C'+R;
L=(P_k_1*C')/Sk;
x_k=x_k_1+L*ek;
P_k=P_k_1-L*C*P_k_1;
P_k=(P_k+P_k')/2;
umin=[umin1;umin2;];  
for i=1:M
    b11{i}=umin-uu;
end
b1=cat(1,b11{1:M});  
umax=[umax1;umax2]; 
for k=1:M
    b21{k}=umax-uu;
end
b2=cat(1,b21{1:M});
H=e1'*Z*e1+W;
H=(H+H')/2;
f=-e1'*Z*(Yr-F*x_k-e2*delt_dk);
S1=[S;-S];
b=[b2;-b1];
delt_umin=[delt_umin1;delt_umin2];
delt_umax=[delt_umax1;delt_umax2];
for i=1:M
    lb1{i}=delt_umin;
end
lb=cat(1,lb1{1:M});
for j=1:M
    ub1{j}=delt_umax;
end
ub=cat(1,ub1{1:M});
[dU,Fval,QP]=quadprog(H,f,S1,b,[],[],lb,ub);
if QP>0
du=[eye(nu),zeros(nu,nu*M-nu)]*dU;
uu=uu+du;
end
ud=uu;
end
end